/**
* user:  C044
* fname: Илия Светлинов Петров
* lname: СОФИЯ
* task:  travel
* score: 40.0
* date:  2019-05-11 06:56:21.123873
*/
#include <iostream>
#include <vector>
#include <map>

const int MAX_N = 1e5 + 10;

std::vector<int> nbrs[MAX_N];

std::map<std::pair<int, int>, int> matrix;

std::vector<bool> used;

int query(int u, int v)
{
	if(matrix.find({u, v}) != matrix.end())
	{
		return matrix[{u, v}];
	}

	used[u] = true;
	
	for(int i = 0; i < nbrs[u].size(); ++ i)
	{
		int curr = nbrs[u][i];
		if(used[curr]) continue;
		int res = query(curr, v);
		if(res == 0)
		{
			matrix.insert({{curr, v}, u});
		}else
		{
			matrix.insert({{u, v}, curr});
			used[u] = false;
			return matrix[{u, v}];
		}
	}

	used[u] = false;
	return 0;
}

int main()
{
	std::cin.tie(NULL);
	std::cout.tie(NULL);
	std::ios_base::sync_with_stdio(false);

	for(int i = 0; i < MAX_N; ++ i)
	{
		matrix.insert({{i, i}, i});
	}

	int n, m;
	std::cin >> n >> m;

	used.resize(n + 1);

	for(int i = 1; i < n; ++ i)
	{
		int u, v;
		std::cin >> u >> v;
		nbrs[u].push_back(v);
		nbrs[v].push_back(u);
	}

	for(int i = 0; i < m; ++ i)
	{
		int u, v;
		std::cin >> u >> v;
		std::cout << query(u, v) << '\n';
	}

	return 0;
}